/* --COPYRIGHT--,BSD
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
#ifndef BUTTON_H_
#define BUTTON_H_

/*
 * Button parameter defines.
 */
#define BUTTON_WIDTH        144
#define BUTTON_HEIGHT       36
#define BUTTON_BOARDER      2
#define BUTTON_SEPARATION   42

/*
 * Button location defines.
 */
#define BUTTONS_START_X     172
#define BUTTONS_START_Y1    28
#define BUTTONS_START_Y2    (BUTTONS_START_Y1 + BUTTON_SEPARATION)
#define BUTTONS_START_Y3    (BUTTONS_START_Y2 + BUTTON_SEPARATION)
#define BUTTONS_START_Y4    (BUTTONS_START_Y3 + BUTTON_SEPARATION)
#define BUTTONS_START_Y5    (BUTTONS_START_Y4 + BUTTON_SEPARATION)

/*
 * Math mode float button.
 */
extern tRectangle buttonMathModeFloatBoarder;
extern tRectangle buttonMathModeFloatFill;

/*
 * Math mode IQmathLib button.
 */
extern tRectangle buttonMathModeIQmathBoarder;
extern tRectangle buttonMathModeIQmathFill;

/*
 * Shape cube button.
 */
extern tRectangle buttonShapeCubeBoarder;
extern tRectangle buttonShapeCubeFill;

/*
 * Shape dodecahedron button.
 */
extern tRectangle buttonShapeDodecahedronBoarder;
extern tRectangle buttonShapeDodecahedronFill;

/*
 * Shape hypercube button.
 */
extern tRectangle buttonShapeHypercubeBoarder;
extern tRectangle buttonShapeHypercubeFill;

/*
 * Prototypes.
 */
extern void button_drawButton(tRectangle *boarder,
                              uint32_t boarderColor,
                              tRectangle *fill,
                              uint32_t fillColor,
                              char *text);

#endif //BUTTON_H_
