/* --COPYRIGHT--,BSD
 * Copyright (c) 2015, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
#ifndef SHAPES_H_
#define SHAPES_H_

#include "demo.h"

/*
 * Constant definitions.
 */
#define ZERO        (0.000000)  // 0.0
#define ONE         (1.000000)  // 1.0
#define PHI         (1.618034)  // (1 + sqrt(5))/2
#define INV_PHI     (0.618034)  // 2 / (1 + sqrt(5))
#define TWO_PI      (6.283185)  // 2*pi

/*
 * Shape definitions.
 */
#define SHAPE_CUBE_SIZE         12                      // number of lines
#define SHAPE_DODECAHEDRON_SIZE 30                      // number of lines
#define SHAPE_HYPERCUBE_SIZE    32                      // number of lines
#define SHAPE_MAX_SIZE          SHAPE_HYPERCUBE_SIZE    // largest size

/*
 * Constant shapes
 */
extern const qVector3D gc_qCube3D[SHAPE_CUBE_SIZE][2];
extern const fVector3D gc_fCube3D[SHAPE_CUBE_SIZE][2];
extern const qVector3D gc_qDodecahedron3D[SHAPE_DODECAHEDRON_SIZE][2];
extern const fVector3D gc_fDodecahedron3D[SHAPE_DODECAHEDRON_SIZE][2];
extern const qVector4D gc_qHypercube4D[SHAPE_HYPERCUBE_SIZE][2];
extern const fVector4D gc_fHypercube4D[SHAPE_HYPERCUBE_SIZE][2];

#endif  //SHAPES_H_
